<template>
  <div>
    <el-container>
      <el-aside width="350px">
        <div class="JKWTree-tree">
          <h3>计件定额管理</h3>
          <el-tree :data="treeData" :props="defaultProps" @node-click="handleNodeClick"></el-tree>
        </div>
      </el-aside>
      <el-container>
        <el-main>
          <div class="gva-search-box">
            <!-- <el-form ref="elSearchFormRef" :inline="true" :model="searchInfo" class="demo-form-inline" :rules="searchRule" @keyup.enter="onSubmit">
              <el-form-item label="创建日期" prop="createdAt">
                <template #label>
        <span>
          创建日期
          <el-tooltip content="搜索范围是开始日期（包含）至结束日期（不包含）">
            <el-icon><QuestionFilled /></el-icon>
          </el-tooltip>
        </span>
                </template>
                <el-date-picker v-model="searchInfo.startCreatedAt" type="datetime" placeholder="开始日期" :disabled-date="time=> searchInfo.endCreatedAt ? time.getTime() > searchInfo.endCreatedAt.getTime() : false"></el-date-picker>
                —
                <el-date-picker v-model="searchInfo.endCreatedAt" type="datetime" placeholder="结束日期" :disabled-date="time=> searchInfo.startCreatedAt ? time.getTime() < searchInfo.startCreatedAt.getTime() : false"></el-date-picker>
              </el-form-item>
              <el-form-item>
                <el-button type="primary" icon="search" @click="onSubmit">查询</el-button>
                <el-button icon="refresh" @click="onReset">重置</el-button>
              </el-form-item>
            </el-form> -->
			<div class="gva-btn-list">
			  <el-button type="primary" icon="upload" @click="bacthEditClick">定额参数批量修改excel</el-button>
			  <el-button type="primary" icon="plus" @click="bacthSubmit">更新</el-button>
			</div>
          </div>
          <div class="gva-table-box">
            <!-- <div class="gva-btn-list">
			  <el-button type="primary" icon="upload" @click="">导出到excel</el-button>
			  <el-button type="primary" icon="plus" @click="getDetails(2)">详情</el-button>
            </div> -->
            <el-table
                ref="multipleTable"
				stripe
            	border
                style="width: 100%"
                tooltip-effect="dark"
                :data="tableData"
                row-key="ID"
                @selection-change="handleSelectionChange"
            	@row-dblclick="updateCompanyFunc"
            	:show-overflow-tooltip="true"
            	highlight-current-row="true"
            >
              <el-table-column align="left" label="定额代号" prop="sys_bh" width="120" />
              <el-table-column align="left" label="名称备注" prop="sys_mc" width="210" />
              <el-table-column align="left" label="使用工序" prop="use_gx" width="88" />
			  <el-table-column align="left" label="适用机型" prop="use_machine" width="88" />
			  <el-table-column fixed="right" v-slot="scope" align="left" label="日定额" width="100" >
			      <el-input @input="inputClick" v-model="scope.row.daily_quota" :clearable="false"/>
			  </el-table-column>
			  <el-table-column fixed="right" v-slot="scope" align="left" label="千件工价" width="100" >
			      <el-input @input="inputClick" v-model="scope.row.thousand_piece" :clearable="false"/>
			  </el-table-column>
			  <el-table-column fixed="right" v-slot="scope" align="left" label="补产标准" width="100" >
			      <el-input @input="inputClick" v-model="scope.row.production_standard" :clearable="false"/>
			  </el-table-column>
			 <!-- <el-table-column align="left" label="原日定额" prop="daily_quota" width="90" />
			  <el-table-column align="left" label="原千件工价" prop="thousand_piece" width="100" />
			  <el-table-column align="left" label="原补产标准" prop="production_standard" width="100" /> -->
			 <!-- <el-table-column fixed="right" v-slot="scope" align="left" label="新日定额" width="100" >
			      <el-input @input="inputClick" v-model="scope.row.daily_quota" :clearable="false"/>
			  </el-table-column>
			  <el-table-column fixed="right" v-slot="scope" align="left" label="新千件工价" width="100" >
			      <el-input @input="inputClick" v-model="scope.row.thousand_piece" :clearable="false"/>
			  </el-table-column>
			  <el-table-column fixed="right" v-slot="scope" align="left" label="新补产标准" width="100" >
			      <el-input @input="inputClick" v-model="scope.row.production_standard" :clearable="false"/>
			  </el-table-column> -->
			  <!-- <el-table-column v-slot="scope" align="left" label="新补产标准" width="100">
				  	<el-form-item :prop="'tableData.'+scope.row+'.production_standard'">
				  		<el-input v-model="scope.row.production_standard" :clearable="true"/>
				  	</el-form-item>
              </el-table-column> -->
			  <el-table-column v-slot="scope" v-if="false" align="left" label="UniqId" width="100" >
			      <el-input v-model="scope.row.UniqId" :clearable="false"/>
			  </el-table-column>
            </el-table>
            <!-- <div class="gva-pagination">
              <el-pagination
                  layout="total, sizes, prev, pager, next, jumper"
                  :current-page="page"
                  :page-size="pageSize"
                  :page-sizes="[10, 30, 50, 100]"
                  :total="total"
                  @current-change="handleCurrentChange"
                  @size-change="handleSizeChange"
				  :row-style="{ height: '20px' }"
				  :cell-style="{ padding: '0px' }" :header-row-style="{ height: '20px' }"
				  :header-cell-style="{ padding: '0px' }"
              />
            </div> -->
          </div>
          <el-dialog v-model="dialogFormVisible" :before-close="closeDialog" :title="type==='create'?'添加':'修改'" destroy-on-close>
            <el-scrollbar height="500px">
              <el-form :model="formData" label-position="right" ref="elFormRef" :rules="rule" label-width="80px">
                <el-form-item label="address字段:"  prop="address" >
                  <el-input v-model="formData.address" :clearable="true"  placeholder="请输入address字段" />
                </el-form-item>
                <el-form-item label="image字段:"  prop="image" >
                  <el-input v-model="formData.image" :clearable="true"  placeholder="请输入image字段" />
                </el-form-item>
                <el-form-item label="name字段:"  prop="name" >
                  <el-input v-model="formData.name" :clearable="true"  placeholder="请输入name字段" />
                </el-form-item>
              </el-form>
            </el-scrollbar>
            <template #footer>
              <div class="dialog-footer">
                <el-button @click="closeDialog">取 消</el-button>
                <el-button type="primary" @click="enterDialog">确 定</el-button>
              </div>
            </template>
          </el-dialog>

          <el-dialog v-model="detailShow" style="width: 800px" lock-scroll :before-close="closeDetailShow" :title="`当前编码:${pieceData.sys_bh}`" destroy-on-close>
            <el-scrollbar height="300px">
              <el-descriptions column="1" border>
                <el-descriptions-item label="编号">
                  {{ pieceData.sys_bh }}
                </el-descriptions-item>
                <el-descriptions-item label="名称">
                  {{ pieceData.sys_mc }}
                </el-descriptions-item>
                <el-descriptions-item label="适用工序">
                  {{ pieceData.sygx }}
                </el-descriptions-item>
				<el-descriptions-item label="适用机型">
				  {{ pieceData.syjx }}
				</el-descriptions-item>
              </el-descriptions>
			  <el-descriptions column="3" border>
			  	<el-descriptions-item label="日定额">
			  	  {{ pieceData.daily_quota }}
			  	</el-descriptions-item>
				<el-descriptions-item label="千件工价">
				  {{ pieceData.thousand_piece }}
				</el-descriptions-item>
				<el-descriptions-item label="小时补产标准">
				  {{ pieceData.production_standard }}
				</el-descriptions-item>
			  </el-descriptions>
			  <el-descriptions column="10" direction="vertical" border>
			    <el-descriptions-item label="机长">
			      {{ pieceData.fir_proportion }}
			    </el-descriptions-item>
			    <el-descriptions-item label="副机">
			      {{ pieceData.sec_proportion }}
			    </el-descriptions-item>
			    <el-descriptions-item label="调墨">
			      {{ pieceData.ink_proportion }}
			    </el-descriptions-item>
			  	<el-descriptions-item label="二手">
			  	  {{ pieceData.second_hand_proportion }}
			  	</el-descriptions-item>
			  	<el-descriptions-item label="飞达">
			  	  {{ pieceData.feeder_proportion }}
			  	</el-descriptions-item>
				<el-descriptions-item label="辅助">
				  {{ pieceData.auxiliary_proportion }}
				</el-descriptions-item>
				<el-descriptions-item label="放卷">
				  {{ pieceData.unwinder_proportion }}
				</el-descriptions-item>
				<el-descriptions-item label="分切1">
				  {{ pieceData.cutting_one_proportion }}
				</el-descriptions-item>
				<el-descriptions-item label="分切2">
				  {{ pieceData.cutting_two_proportion }}
				</el-descriptions-item>
				<el-descriptions-item label="检验">
				  {{ pieceData.inspect_proportion }}
				</el-descriptions-item>
			  </el-descriptions>
            </el-scrollbar>
          </el-dialog>
        </el-main>
      </el-container>
    </el-container>
  </div>
</template>

<script setup>
import {
  getOnePieceWork,
  getPieceWork,
  getPieceParams,
  editAllParams
} from '@/api/mes/job'
import {
  createCompany,
  deleteCompany,
  deleteCompanyByIds,
  updateCompany,
  findCompany,
  getCompanyList
} from '@/api/company'

// 全量引入格式化工具 请按需保留
import { getDictFunc, formatDate, formatBoolean, filterDict, ReturnArrImg, onDownloadFile } from '@/utils/format'
import { ElMessage, ElMessageBox } from 'element-plus'
import { ref, reactive } from 'vue'

defineOptions({
    name: 'Company'
})


const treeData=ref([])
const PieceWork = async() => {
  const getPieceWorks = await getPieceWork()
  if (getPieceWorks.code === 0) {
	  
	  const transformedData1 = getPieceWorks.data.machineData.map(item => ({
	          label: `${item.sys_mc}【${item.sys_bh}】`,
			  params: {
			    code: item.sys_bh,
			  },
	          children: item.child.map(sysItem => ({
	            label: `${sysItem.gx} ${sysItem.jx}【${sysItem.sys_bh}】`,
	            params: {
	              code: sysItem.sys_bh,
	            },
				children: sysItem.children.map(syssItem => ({
				  label: `${syssItem.sys_mc}【${syssItem.sys_bh}】`,
				  params: {
				    code: syssItem.sys_bh,
				  },
				}))
	          })),
	        }));
		const transformedData2 = getPieceWorks.data.handData.map(item => ({
		        label: `${item.gx}【${item.sys_bh}】`,
				params: {
				  code: item.sys_bh,
				},
		        children: item.child.map(sysItem => ({
		          label: `${sysItem.sys_mc}【${sysItem.sys_bh}】`,
		          params: {
		            code: sysItem.sys_bh,
		          },
						children: sysItem.children.map(syssItem => ({
						  label: `${syssItem.sys_mc}【${syssItem.sys_bh}】`,
						  params: {
						    code: syssItem.sys_bh,
						  },
						}))
		        })),
		      }));
			  
	    treeData.value = [
	    	{
	    		label: '机器作业计件定额',
	    		children:transformedData1,
				code:'020'
	    	},
			{
				label: '人工作业计件定额',
				children:transformedData2,
				code:'030'
			}
	    ]
  }
}
PieceWork()
const handleNodeClick = (node,check) => {
  //存放当前节点的nodeId
  // if (node.paramss) {
  // 		sys_bh.value = node.paramss.code;
  // 		getDetails();
		// return false;
  // 	}
  // if (node.params) {
  // 		sys_bh.value = node.params.code;
  // 		getDetails();
  // 	}
  if(node.children==null){
  	sys_bh.value = node.params.code;
  	getDetails();
  }else{
  	if(node.children.length==0){
  		sys_bh.value = node.params.code;
  		getDetails();
  	}
  }
  if(node.params){
	  code.value=node.params.code
  }else{
	  code.value=node.code
  }
  // console.log(code.value);
  // console.log(node,check);
}
// 自动化生成的字典（可能为空）以及字段
const formData = ref({
        address: '',
        image: '',
        name: '',
        })


// 验证规则
const rule = reactive({
})

const searchRule = reactive({
  createdAt: [
    { validator: (rule, value, callback) => {
      if (searchInfo.value.startCreatedAt && !searchInfo.value.endCreatedAt) {
        callback(new Error('请填写结束日期'))
      } else if (!searchInfo.value.startCreatedAt && searchInfo.value.endCreatedAt) {
        callback(new Error('请填写开始日期'))
      } else if (searchInfo.value.startCreatedAt && searchInfo.value.endCreatedAt && (searchInfo.value.startCreatedAt.getTime() === searchInfo.value.endCreatedAt.getTime() || searchInfo.value.startCreatedAt.getTime() > searchInfo.value.endCreatedAt.getTime())) {
        callback(new Error('开始日期应当早于结束日期'))
      } else {
        callback()
      }
    }, trigger: 'change' }
  ],
})

const elFormRef = ref()
const elSearchFormRef = ref()

// =========== 表格控制部分 ===========
const page = ref(1)
const total = ref(0)
const pageSize = ref(10)
const tableData = ref([])
const searchInfo = ref({})
const sys_bh = ref()
const code = ref()
const pieceData = ref([])
const isSubmit = ref(0)

// 重置
const onReset = () => {
  searchInfo.value = {}
  getTableData()
}

// 搜索
const onSubmit = () => {
  elSearchFormRef.value?.validate(async(valid) => {
    if (!valid) return
    page.value = 1
    pageSize.value = 10
    getTableData()
  })
}

// 分页
const handleSizeChange = (val) => {
  pageSize.value = val
  getTableData()
}

// 修改页面容量
const handleCurrentChange = (val) => {
  page.value = val
  getTableData()
}


const inputClick = async() => {
	isSubmit.value=1
}
const bacthEditClick = async() => {
	if(code.value.length>2){
		const getPieceParamss = await getPieceParams({code:code.value})
		if (getPieceParamss.code === 0) {
			tableData.value = getPieceParamss.data
			isSubmit.value=0
		}
	}
}
const bacthSubmit = async() => {
	if(isSubmit.value===1){
		const editAllParamss = await editAllParams(tableData.value)
		if (editAllParamss.code === 0) {
			  ElMessage({
			          type: 'success',
			          message: '更新成功'
			      })
				  isSubmit.value=0
		}
		console.log(tableData.value)
	}
	
}
// 查询
// const getTableData = async() => {
//   const table = await getCompanyList({ page: page.value, pageSize: pageSize.value, ...searchInfo.value })
//   if (table.code === 0) {
//     tableData.value = table.data.list
//     total.value = table.data.total
//     page.value = table.data.page
//     pageSize.value = table.data.pageSize
//   }
// }

// getTableData()

// ============== 表格控制部分结束 ===============

// 获取需要的字典 可能为空 按需保留
const setOptions = async () =>{
}

// 获取需要的字典 可能为空 按需保留
setOptions()


// 多选数据
const multipleSelection = ref([])
// 多选
const handleSelectionChange = (val) => {
    multipleSelection.value = val
}

// 删除行
const deleteRow = (row) => {
    ElMessageBox.confirm('确定要删除吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
    }).then(() => {
            deleteCompanyFunc(row)
        })
    }


// 批量删除控制标记
const deleteVisible = ref(false)

// 多选删除
const onDelete = async() => {
      const ids = []
      if (multipleSelection.value.length === 0) {
        ElMessage({
          type: 'warning',
          message: '请选择要删除的数据'
        })
        return
      }
      multipleSelection.value &&
        multipleSelection.value.map(item => {
          ids.push(item.ID)
        })
      const res = await deleteCompanyByIds({ ids })
      if (res.code === 0) {
        ElMessage({
          type: 'success',
          message: '删除成功'
        })
        if (tableData.value.length === ids.length && page.value > 1) {
          page.value--
        }
        deleteVisible.value = false
        getTableData()
      }
    }

// 行为控制标记（弹窗内部需要增还是改）
const type = ref('')

// 更新行
const updateCompanyFunc = async(row) => {
    // const res = await findCompany({ ID: row.ID })
    // type.value = 'update'
    // if (res.code === 0) {
    //     formData.value = res.data.recompany
    //     dialogFormVisible.value = true
    // }
}


// 删除行
const deleteCompanyFunc = async (row) => {
    const res = await deleteCompany({ ID: row.ID })
    if (res.code === 0) {
        ElMessage({
                type: 'success',
                message: '删除成功'
            })
            if (tableData.value.length === 1 && page.value > 1) {
            page.value--
        }
        getTableData()
    }
}

// 弹窗控制标记
const dialogFormVisible = ref(false)


// 查看详情控制标记
const detailShow = ref(false)


// 打开详情弹窗
const openDetailShow = () => {
  detailShow.value = true
}


// 打开详情
const getDetails = async () => {
	const getOnePieceWorks = await getOnePieceWork({code:sys_bh.value})
	if (getOnePieceWorks.code === 0) {
	  // getProcessLosss.data[0].forEach(function(i,index){
	  // 	console.log(i)
	  // })
	  pieceData.value=getOnePieceWorks.data[0]
	  openDetailShow()
	}
	openDetailShow()
  // 打开弹窗
  // const res = await findCompany({ ID: row })
  // if (res.code === 0) {
  //   formData.value = res.data.recompany
  //   openDetailShow()
  // }
}


// 关闭详情弹窗
const closeDetailShow = () => {
  detailShow.value = false
  formData.value = {
          address: '',
          image: '',
          name: '',
          }
}


// 打开弹窗
const openDialog = () => {
    // type.value = 'create'
    dialogFormVisible.value = true
}

// 关闭弹窗
const closeDialog = () => {
    dialogFormVisible.value = false
    formData.value = {
        address: '',
        image: '',
        name: '',
        }
}
// 弹窗确定
const enterDialog = async () => {
     elFormRef.value?.validate( async (valid) => {
             if (!valid) return
              let res
              switch (type.value) {
                case 'create':
                  res = await createCompany(formData.value)
                  break
                case 'update':
                  res = await updateCompany(formData.value)
                  break
                default:
                  res = await createCompany(formData.value)
                  break
              }
              if (res.code === 0) {
                ElMessage({
                  type: 'success',
                  message: '创建/更改成功'
                })
                closeDialog()
                getTableData()
              }
      })
}

</script>

<style>
.JKWTree-container {
  display: flex;
}

.JKWTree-tree {
  width: 350px;
  background-color: #fff;
  padding: 10px;
  margin-right: 20px;
}

.JKWTree-tree h3 {
  font-size: 15px;
  font-weight: 700;
  margin: 10px 0;
}

.JKWTree-content {
  flex: 1;
}
</style>
